<template>
  <v-dialog v-model="dialog" persistent scrollable width="420" class="mt-3">
    <v-btn slot="activator" flat icon v-tooltip:left="{html: 'Create game'}">
      <v-icon>add_circle_outline</v-icon>
    </v-btn>

    <v-card>
      <v-card-title class="headline">Create game</v-card-title>
      <v-form method="post" @submit.prevent="createGame" ref="gameForm">
        <v-card-text v-if="!created">
          <v-select label="Game Type" v-model="game['type']" :items="$store.state.gameTypes" :rules="[$rules.required]" required></v-select>
          <v-text-field label="Place" v-model="game['place']" :rules="[$rules.required]" required />
          <v-menu lazy v-model="picker['date']" :close-on-content-click="false" max-width="290" :nudge-left="45">
            <v-text-field slot="activator" label="Date" v-model="date" readonly :rules="[$rules.required]" required></v-text-field>
            <v-date-picker v-model="date" scrollable actions>
              <template scope="{save, cancel}">
                <v-card-actions>
                  <v-btn flat primary @click="cancel()">Cancel</v-btn>
                  <v-btn flat primary @click="save()">Done</v-btn>
                </v-card-actions>
              </template>
            </v-date-picker>
          </v-menu>
          <v-menu lazy v-model="picker['time']" :close-on-content-click="false" max-width="290" :nudge-left="45">
            <v-text-field slot="activator" label="Time" v-model="time" readonly :rules="[$rules.required]" required></v-text-field>
            <v-time-picker v-model="time" actions>
              <template scope="{save, cancel}">
                <v-card-actions>
                  <v-btn flat primary @click="cancel()">Cancel</v-btn>
                  <v-btn flat primary @click="save()">Done</v-btn>
                </v-card-actions>
              </template>
            </v-time-picker>
          </v-menu>
          <v-text-field label="Duration" v-model="game['duration']" />
        </v-card-text>
        <v-card-text v-else>
          <p>The game has been created.</p>
        </v-card-text>
        <v-card-actions>
          <v-spacer />
          <v-btn flat @click="close">{{created ? 'Done' : 'Cancel'}}</v-btn>
          <v-btn flat primary type="submit" :loading="creating" :disabled="creating" v-if="!created">
            Create
            <span slot="loader">Creating...</span>
          </v-btn>
        </v-card-actions>
      </v-form>
    </v-card>
  </v-dialog>
</template>

<script>
  import moment from 'moment'
  export default {
    name: 'create-game',
    watch: {
      date (to, from) {
        let format = this.time ? moment(to + ' ' + this.time, 'YYYY-MM-DD h:mma') : moment(to, 'YYYY-MM-DD')
        this.game.time = format.unix()
      },
      time (to, from) {
        let format = this.date ? moment(to + ' ' + this.date, 'h:mma YYYY-MM-DD') : moment(to, 'h:mma')
        this.game.time = format.unix()
      }
    },
    data () {
      return {
        dialog: false,
        creating: false,
        created: false,
        picker: {},
        game: {
          status: 'waiting'
        },
        date: null,
        time: null,
        db: this.$database.ref('games')
      }
    },
    methods: {
      close () {
        this.dialog = false
        this.$refs.gameForm.reset()
      },
      createGame () {
        this.creating = true
        if (this.$refs.gameForm.validate()) {
          this.db.push(this.game).then(data => {
            this.creating = false
            this.created = true
            this.$refs.gameForm.reset()
          }).catch(error => console.log({error}))
        }
      }
    }
  }
</script>

<style scoped>
  .menu {
    width: 100%;
  }
</style>
